import java.awt.*;
import java.util.ArrayList;
//import java.awt.event.*; 
//import java.lang.Math.*;

import javax.swing.JComboBox;
import javax.swing.text.html.HTMLDocument.Iterator;

/**
 * Implementacia Margolusovho automatu
 * @author = Ivan Klimko
 * @version = 2.0
 */
public class MargPanel extends AutomatPanel
{
	private BBA user_intf;						//referencia na panel volieb
	
	private int sizX=16;							//velkost mriezky X
	private int sizY=16;							//                Y

	private int[][] Data;						//Data
	private int gulaX=1;
	private int gulaY=1;
	private int[][] Data3;
	private boolean faza3;
	
	private boolean faza;						//stav okolia
	private boolean zmena;						//pomocna premenna pre autostop

	//volby pre demo a mod ohranicenia              , sfericky = priestorovy,"ohraniceny" gulov
	private int demo = 0;
	//pravidla
						    //  0  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15
	private int[] swapArray = { 0, 8, 4, 3, 2, 5, 9, 7, 1, 6,10,11,12,13,14,15}; //margolusove pravidla;
                 // swap array = vymenit maticu/mriezku(6) ,ak sa zhoduje index s obsahom pola tak sa nemeni okolie (10)
// ----------------------------------------------------------------
   /**
	 * Konstruktor
	 * @param BBA ui referencia na triedu obsahujucu panel volieb
	 */
	public MargPanel(BBA ui) //bez parametrov nastavi defaultne aspon jedno demo
	{
		this.user_intf=ui;
		Data3 = new int[sizX][sizY];
	}
	
	
/**
 * implement8cia funkcie pre priznak gule X / JCheckBox signalX
 * @param chb_signalX b
 */
	public void setX(boolean b) {
			if (b==false)
				gulaX=0;
			else
				gulaX=1;									
	}

	/**
	 * impelmentacia funkcie pre priznak gule Y / JCheckBox signalY
	 * @param chb_signalY b
	 */
	public void setY(boolean b) {
		if (b==false)
			gulaY=0;
		else
			gulaY=1;
	}
	

	/**
	 * funkcia pre ulozenie vsetkych navaolenych gul uzivatelom 
	 */
	public void saveData(){
		faza3=faza;  //zpamatava rozlozenie ciar
		for(int i=0;i<sizX;i++)
			for(int j=0;j<sizY;j++)
		       Data3[i][j]=Data[i][j];
		     }
		
	/**
	 * funkcia pre vynulovanie vsetky navolenych gul, je volana v clear()
	 */
	public void clearData3(){
		for(int i=0;i<sizX;i++)
			for(int j=0;j<sizY;j++)
				Data3[i][j]=0;
		     }
	
//vola sa pri inicializovani automatu	
	public void InitSetDemo(){
		faza = false;
		sizX=16;
		sizY=16;
		SetSize();
		Data[ 0][ 0]=Data[ 2][ 2]=1;  // gula 
	    repaint();
	}
	
	/**
	 * 	implementacia funkcie pre nastavenie dema
	 * @param int demo - poradove cislo dema
	 */	
	public void SetDemo(int demo)
	{
		faza = false;
		this.demo = demo;		
		krok=0;
		switch(demo)
		{
		case 0://pohyb gule
			   sizX=16;
			   sizY=16;
			   SetSize();
			   Data[ 0][ 0]=Data[ 2][ 2]=1;  // gula  
			   break;
		case 1://vlastne demo
			    faza=faza3;  // nastavi sa rozlozenie ciar pri poslednej volbe gule
				sizX=16;
				sizY=16;
				SetSize();
//			   	Data=Data3;
				
				for(int i=0;i<sizX;i++)
					for(int j=0;j<sizY;j++)
						Data[i][j]=Data3[i][j];
			   break;
		case 2://stabilny prvok
	//		listData.clear();   
			sizX=16;
			   sizY=16;   
			   SetSize();
			   Data[ 7][ 8]=Data[ 8][ 8]=Data[ 7][ 9]=Data[ 8][ 9]=1; //stabilny stvorec
			   break;
   		case 3://odraz od zrkadla
			   sizX=16;
			   sizY=16;SetSize();
			   Data[ 2][ 2]=Data[ 4][ 4]=1; //gula
			   Data[13][15]=Data[11][13]=1; //gula
			   //zrkadlo
			   Data[ 5][ 8]=Data[ 6][ 8]=Data[ 7][ 8]=Data[ 8][ 8]=Data[ 9][ 8]=Data[10][ 8]=1;
			   Data[ 5][ 9]=Data[ 6][ 9]=Data[ 7][ 9]=Data[ 8][ 9]=Data[ 9][ 9]=Data[10][ 9]=1;
			   break;
		case 4://posun o 2 A
			   sizX=16;
			   sizY=16;   
			   SetSize();
			   Data[ 0][ 2]=Data[ 2][ 4]=1; //gula 
			   //zrkadlo horne
			   Data[ 6][ 3]=Data[ 7][ 3]=Data[ 8][ 3]=Data[ 9][ 3]=1;
			   Data[ 6][ 4]=Data[ 7][ 4]=Data[ 8][ 4]=Data[ 9][ 4]=1;
			   //zrkadlo dolne
			   Data[ 4][ 9]=Data[ 5][ 9]=Data[ 6][ 9]=Data[ 7][ 9]=1;
			   Data[ 4][10]=Data[ 5][10]=Data[ 6][10]=Data[ 7][10]=1;
			   break;
		case 5://posun o 4 B
			   sizX=16;
			   sizY=16;   
			   SetSize();
			   Data[ 0][ 2]=Data[ 2][ 4]=1; //gula 
			   //zrkadlo horne
			   Data[10][ 3]=Data[11][ 3]=Data[12][ 3]=Data[13][ 3]=1;
			   Data[10][ 4]=Data[11][ 4]=Data[12][ 4]=Data[13][ 4]=1;
			   //zrkadlo dolne
			   Data[ 6][11]=Data[ 7][11]=Data[ 8][11]=Data[ 9][11]=1;
			   Data[ 6][12]=Data[ 7][12]=Data[ 8][12]=Data[ 9][12]=1;
			   break;
		case 6://zrazka guli - I gate
			   sizX=16;
			   sizY=16;   
			   SetSize();
 		       Data[ 0][ 0]=Data[ 2][ 2]=gulaX;
			   Data[ 2][13]=Data[ 0][15]=gulaY;
			   break;
		case 7://S gate
			   sizX=16;
			   sizY=16;   
			   SetSize();
			   Data[ 0][ 2]=Data[ 2][ 4]=gulaX;
			   Data[ 0][13]=Data[ 2][11]=gulaY;
			   //zrkadlo 1
			   Data[ 6][ 1]=Data[ 7][ 1]=Data[ 8][ 1]=Data[ 9][ 1]=1;
			   Data[ 6][ 2]=Data[ 7][ 2]=Data[ 8][ 2]=Data[ 9][ 2]=1;
			   //zrkadlo 2
			   Data[ 4][11]=Data[ 5][11]=Data[ 6][11]=Data[ 7][11]=1;
			   Data[ 4][12]=Data[ 5][12]=Data[ 6][12]=Data[ 7][12]=1;
			   break;
		case 8://nontrivial crossover
			   sizX=16;
			   sizY=16;   
			   SetSize();
			   Data[ 0][ 2]=Data[ 2][ 4]=gulaX;
			   Data[ 0][13]=Data[ 2][11]=gulaY;
			   //zrkadlo 1
			   Data[ 4][ 3]=Data[ 5][ 3]=Data[ 6][ 3]=Data[ 7][ 3]=1;
			   Data[ 4][ 4]=Data[ 5][ 4]=Data[ 6][ 4]=Data[ 7][ 4]=1;
			   //zrkadlo 2
			   Data[ 4][11]=Data[ 5][11]=Data[ 6][11]=Data[ 7][11]=1;
			   Data[ 4][12]=Data[ 5][12]=Data[ 6][12]=Data[ 7][12]=1;
			   break;
		case 9://delay (oneskorenie)
			   sizX=16;
			   sizY=16;   
			   SetSize();
			   Data[ 0][ 15]=Data[ 2][ 13]=1; //gula
			   //Data[ 0][13]=Data[ 2][11]=gulaY;
			   //zrkadlo 1
			   Data[ 4][ 5]=Data[ 5][ 5]=Data[ 6][ 5]=Data[ 7][ 5]=1;
			   Data[ 4][ 6]=Data[ 5][ 6]=Data[ 6][ 6]=Data[ 7][ 6]=1;
			   Data[ 4][ 7]=Data[ 5][ 7]=Data[ 6][ 7]=Data[ 7][ 7]=1;
			   Data[ 4][ 8]=Data[ 5][ 8]=Data[ 6][ 8]=Data[ 7][ 8]=1;
			   //zrkadlo 2
			   Data[ 6][13]=Data[ 7][13]=Data[ 8][13]=Data[ 9][13]=1;
			   Data[ 6][14]=Data[ 7][14]=Data[ 8][14]=Data[ 9][14]=1;
//			 zrkadlo 3
			   Data[12][ 7]=Data[12][ 8]=Data[12][ 9]=Data[12][10]=1;
			   Data[13][ 7]=Data[13][ 8]=Data[13][ 9]=Data[13][10]=1;
			   break;
		default: 
			   break;
		}
		user_intf.krokuj(0);
		repaint();         //vola paint asi
		
		
	}
	
	
//vytvorenie pola	
	//tato sa vola interne
	private void SetSize()
	{
		Data = new int[sizX][sizY];		
	}
	
	//pre verejnost po vytvoreni sa vyvola aj prekreslenie
	/**
	 * funkcia pre nastavenie velkosti automatu (v bunkach, nie pixeloch)
	 * @param int x pocet buniek horizontalne
	 * @param int y pocet buniek vertikalne
	 */
	public void SetSize(int x,int y)
	{	
		sizX = x;
		sizY = y;
		SetSize();
		repaint();
	}
	
//reset - reinicializuje
	/**
	 * 	funkcia reinicializuje automat
	 */
	public void reset()
    {
		SetDemo(demo);
		
	}

//clear vymaze vsetko
	/**
     * 	funkcia vymaze plochu automatu
	 */
	public void clear()
	{
		faza=false;
			for(int i=0;i<sizX;i++)
				for(int j=0;j<sizY;j++){
					Data[i][j]=0;	
				}
			clearData3();
			repaint();
	}
	

// ----------------------------------------------------------------
// aplikacia pravidla - prekodovanie (nahradenie okolia)
	private void SwapMargCells(int mgCells[])   // vstupny parameter-okolie- 1-rozmer. pole o 4 prvkoch
	{
		int iCnt, iNewCnt;
						   //  Susedstvo, (okolie sa skalada zo 4 buniek)
		iCnt = mgCells[3]; //1   1  2           //bitove operacie v grafike
		iCnt <<= 1;             // iCnt=iCnt << 1  posunie bity v iCnt dolava o 1 poziciu, prida dalsi bit ak je gula b tom idexe okolia
		iCnt |= mgCells[2]; //2   4  8    ,  iCnt=iCnt | mgCells[2] bitovy sucetOR
		iCnt <<= 1;
		iCnt |= mgCells[1]; //4   1  0     0  0
		iCnt <<= 1;
		iCnt |= mgCells[0]; //8   0  0 na  0  1
						   // 1 sa transformuje na 8
// 0000-0,0001-1,0010-2,0011-3,...,0111-7,1001-9,1111-15   identifukuje rozplozenie okolia (16) a teda pravidlo
		
		iNewCnt = swapArray[iCnt];    // na zaklade hodnoty iCnt, 
		//sa vyberie prvok pola swapArray s tymto indexom iCnt, teda pravidlo a vlozi sa do iNewCnt
		
		if(iNewCnt!=iCnt) zmena=true; //zmena sa nastavi na true
		                              //ak sa nezhoduje index s obsahom meni sa okolie (6)
		mgCells[0] = iNewCnt & 1;         //logicky sucin, na nastavenie na nulu
		iNewCnt >>= 1;                    
		mgCells[1] = iNewCnt & 1;   // pr. ak iNewCnt = 01010 &  0001 = 0000
		iNewCnt >>= 1;              //     ak           01011 &  0001 = 0001
		mgCells[2] = iNewCnt & 1;   // no a potom posunie a takto nastrka obsah iNewCnt do jednotl indexov mgCells, teda aplikuje pravidlo 
		iNewCnt >>= 1;
		mgCells[3] = iNewCnt & 1;
	}

// ----------------------------------------------------------------
// Jedna faza cyklu
	/**
	 * 	nosna funkcia - jeden krok automatu
	 */
	public void step()  //prebehne,prekresli sa,potom sa zavoal reset/teda SetDemo/ ak loop je on, ak nie tak BBA.bba_stop
	{
		int i, j; 
		int c1, c2, r1, r2;
		int mgCells[] = new int[4];  // Margolusove susedstvo 2x2 
		int tempData[][] = new int[sizX][sizY]; //nutne pre paralelny chod
		
		zmena=false;
	 
		//vymena ciar
		// boolean faza def stav okolia, teda ci sa maju posunut ciari (plne a ciarkovane)a tym sa posuva okolie
		
		i= (faza) ? -1 : 0; //  ?? parna faza, posuvame dolava   , prevod hodnoty boolean na int ak ano -1 ak nie 0 a ulozi so int
		while (i < sizX)   
		{   
			c1=i;
			c2=i+1;
			
			j = (faza)? -1 : 0; // parna faza, posuvame nahor
			while (j < sizY)
				{
				r1=j;
				r2=j+1;
				//naplnime mgCells pre aplikaciu pravidla
				
				mgCells[0] = (c1<0||r1<0) ? 0 : Data[c1][r1]; // ul   , ak nakraji tak vynuluj
				mgCells[1] = (c2>=sizX||r1<0) ? 0 : Data[c2][r1]; // ur
				mgCells[2] = (c1<0||r2>=sizY) ? 0 : Data[c1][r2]; // ll
				mgCells[3] = (c2>=sizX||r2>=sizY) ? 0 :Data[c2][r2]; // lr

				
				if ((mgCells[0]+mgCells[1]+mgCells[2]+mgCells[3]) > 0) //iba pre neprazdne bunky pravidlo 0-0 mozme vynechat v tomto pripade
					{
						SwapMargCells(mgCells); // aplikujeme pravidlo
						//prepiseme obsah
						if(c1>=0&&r1>=0) tempData[c1][r1] = mgCells[0];
						if(c2<sizX&&r1>=0) tempData[c2][r1] = mgCells[1];
						if(c1>=0&&r2<sizY) tempData[c1][r2] = mgCells[2];
						if(c2<sizX&&r2<sizY) tempData[c2][r2] = mgCells[3];
					}
				j += 2;
				}
			i += 2;
		}
		krok++;
		user_intf.krokuj(krok);
		faza=!faza;        //  ! je negacia , posun nacitania okolia
		Data=tempData;
		repaint();
		if(autorestart&&!zmena) {
			krok=0;
			reset();	//loop,skoncili sme a reinicializujem 
		}
		if(!autorestart&&!zmena) user_intf.bba_stop();	//no loop,zastavime chod
	}
	
	
//doplnovanie elementov pouzivatelom - spracuje klik na bunku
	/**
	 * 
	 * 	implementacia funkcie doplnovanie elementov pouzivatelom - spracuje klik na bunku
	 * @param int x - suradnica x
	 * @param int y - suradnica y
	 */
	protected void SetElement(int x,int y)
	{   
		if(demo==1){
			
		if(timer==null)
		{
			Dimension d = getSize();
			int GRIDSIZE=Math.min(d.height/sizY,d.width/sizX); //urci velkost mriezky
			int startx=(d.width-GRIDSIZE*sizX)/2; //urci posun  x od [0,0] presuvame [0,0], teda co je ten okraj biely
			int starty=(d.height-GRIDSIZE*sizY)/2; //urci posun y od [0,0] na [startx,starty] 
	
			int posx=(x-startx)/GRIDSIZE;	//urci zodpovedajucu suradnicu bunky
			int posy=(y-starty)/GRIDSIZE;
			Data[posx][posy]=(Data[posx][posy]==1)? 0 : 1; //zmeni stav bunky, ak uz je oznacena a sme na nu klikli tak to vynuluje
	        
		}
		}
	}
//tu sa kresli
	private void kresli(Graphics g)
	{ 
		Dimension d = getSize();  //zisti rozmer komponenty kde bude lezat mriezka
		int GRIDSIZE = Math.min(d.height/sizY,d.width/sizX); //urci velkost mriezky a ulozi do GRIDSIZE
	    int startx = (d.width-GRIDSIZE*sizX)/2; //urci posun  x od [0,0] presuvame [0,0]
		int starty = (d.height-GRIDSIZE*sizY)/2; //urci posun y od [0,0] na [startx,starty] 
		int endx = startx+GRIDSIZE*sizX;
		int endy = starty+GRIDSIZE*sizY;
//		podla fazy sa striedaju pozicie ciarkovanych
		int startx_c = (faza)?startx: startx+GRIDSIZE;  //ciarkovanych
		int starty_c = (faza)?starty: starty+GRIDSIZE; 
		int startx_b = (faza)?startx+GRIDSIZE: startx;  //a plnych ciar
		int starty_b = (faza)?starty+GRIDSIZE: starty;
	
		//mriezka - ciarkovana ciara /siva/; kreslime najprv
		g.setColor(Color.lightGray);
		for (int x = startx_c; x <= endx; x += GRIDSIZE*2) 
		{
			g.drawLine(x, starty, x, endy - 1);
		}
		for (int y = starty_c; y <= endy; y += GRIDSIZE*2)
		{
			g.drawLine(startx, y, endx - 1, y);
		}
		
		//mriezka - plna ciara /cierna/
		g.setColor(Color.black);
		for (int x = startx_b; x <= endx; x += GRIDSIZE*2) 
		{
			g.drawLine(x, starty, x, endy - 1);
		}
		for (int y = starty_b; y <= endy; y += GRIDSIZE*2)
		{
			g.drawLine(startx, y, endx - 1, y);
		}
		//vlastne data
		g.setColor (farba);
		for(int i=0;i<sizX;i++)
			for(int j=0;j<sizY;j++)
				if(Data[i][j]==1)
				{
					//prepocitat do cielovych suradnic
					int targetx=GRIDSIZE*i+startx;
					int targety=GRIDSIZE*j+starty;
							
					g.fillRect(targetx+1,targety+1,GRIDSIZE-1,GRIDSIZE-1);
				}
	}
		/**
		 * vykresluje trajektoriu gul pre I-hradlo
		 * @param g
		 */
		private void kresliIgate(Graphics g)
		{ 
			Dimension d = getSize();  //zisti rozmer komponenty kde bude lezat mriezka
			int GRIDSIZE = Math.min(d.height/sizY,d.width/sizX); //urci velkost mriezky a ulozi do GRIDSIZE
		    int startx = (d.width-GRIDSIZE*sizX)/2; //urci posun  x od [0,0] presuvame [0,0]
			int starty = (d.height-GRIDSIZE*sizY)/2; //urci posun y od [0,0] na [startx,starty] 
			int endx = startx+GRIDSIZE*sizX;
			int endy = starty+GRIDSIZE*sizY;
		g.setColor(Color.RED);
		{
			g.drawLine(startx,starty+2,endx,endy+2);
		}
		g.setColor(Color.GREEN);
		{
			g.drawLine(startx,endy-2,endx,starty-2);
		}
				
		g.setColor(Color.BLUE);
		{
			g.drawLine((endx-startx)/2+startx-GRIDSIZE,(endy-starty)/2+starty+GRIDSIZE,endx,endy+2*GRIDSIZE);
			g.drawLine((endx-startx)/2+startx-GRIDSIZE,(endy-starty)/2+starty-GRIDSIZE,endx,starty-2*GRIDSIZE);
			g.drawLine(startx,starty,(endx-startx)/2+startx-GRIDSIZE,(endy-starty)/2+starty-GRIDSIZE);
			g.drawLine(startx,endy,(endx-startx)/2+startx-GRIDSIZE,(endy-starty)/2+starty+GRIDSIZE);
		}
		
	}
		/**
		 * vykresluje trajektoriu gul pre S-hradlo
		 * @param g
		 */
		private void kresliSgate(Graphics g)
		{ 
			Dimension d = getSize();  //zisti rozmer komponenty kde bude lezat mriezka
			int GRIDSIZE = Math.min(d.height/sizY,d.width/sizX); //urci velkost mriezky a ulozi do GRIDSIZE
		    int startx = (d.width-GRIDSIZE*sizX)/2; //urci posun  x od [0,0] presuvame [0,0]
			int starty = (d.height-GRIDSIZE*sizY)/2; //urci posun y od [0,0] na [startx,starty] 
			int endx = startx+GRIDSIZE*sizX;
			int endy = starty+GRIDSIZE*sizY;
		
		g.setColor(Color.RED);
		{
			g.drawLine(startx,starty+2*GRIDSIZE+2,endx,endy+2*GRIDSIZE+2);
		}
		g.setColor(Color.GREEN);
		{
			g.drawLine(startx+2,endy-2*GRIDSIZE,endx+2,starty-2*GRIDSIZE);
		}

			
		g.setColor(Color.BLUE);
		{
			g.drawLine(startx+5*GRIDSIZE,starty+7*GRIDSIZE,startx+7*GRIDSIZE,starty+5*GRIDSIZE);
			g.drawLine(startx+7*GRIDSIZE,starty+5*GRIDSIZE,startx+8*GRIDSIZE,starty+6*GRIDSIZE);
			g.drawLine(startx+8*GRIDSIZE,starty+6*GRIDSIZE,endx,starty-2*GRIDSIZE);
			g.drawLine(startx,endy-2*GRIDSIZE,startx+5*GRIDSIZE,starty+9*GRIDSIZE);
			g.drawLine(startx+5*GRIDSIZE,starty+9*GRIDSIZE,startx+6*GRIDSIZE,starty+10*GRIDSIZE);
			g.drawLine(startx+6*GRIDSIZE,starty+10*GRIDSIZE,startx+9*GRIDSIZE,starty+7*GRIDSIZE);
			g.drawLine(startx+9*GRIDSIZE,starty+7*GRIDSIZE,endx,endy-2*GRIDSIZE);
			g.drawLine(startx,starty+2*GRIDSIZE,startx+5*GRIDSIZE,starty+7*GRIDSIZE);
         }
	}
		
		/**
		 * vykresluje trajektoriu gul pre netrivialne krizenie
		 * @param g
		 */
		private void kresliNetrivialne(Graphics g)
		{ 
			Dimension d = getSize();  //zisti rozmer komponenty kde bude lezat mriezka
			int GRIDSIZE = Math.min(d.height/sizY,d.width/sizX); //urci velkost mriezky a ulozi do GRIDSIZE
		    int startx = (d.width-GRIDSIZE*sizX)/2; //urci posun  x od [0,0] presuvame [0,0]
			int starty = (d.height-GRIDSIZE*sizY)/2; //urci posun y od [0,0] na [startx,starty] 
			int endx = startx+GRIDSIZE*sizX;
			int endy = starty+GRIDSIZE*sizY;
			
			g.setColor(Color.RED);
			{
				g.drawLine(startx,starty+2*GRIDSIZE+2,endx,endy+2*GRIDSIZE+2);
			}
			g.setColor(Color.GREEN);
			{
				g.drawLine(startx+2,endy-2*GRIDSIZE,endx+2,starty-2*GRIDSIZE);
			}
			g.setColor(Color.BLUE);
			{
				g.drawLine(startx,endy-2*GRIDSIZE,startx+5*GRIDSIZE,starty+9*GRIDSIZE);
				g.drawLine(startx+5*GRIDSIZE,starty+9*GRIDSIZE,startx+6*GRIDSIZE,starty+10*GRIDSIZE);
				g.drawLine(startx+6*GRIDSIZE,starty+10*GRIDSIZE,startx+7*GRIDSIZE,starty+9*GRIDSIZE);
				g.drawLine(startx+5*GRIDSIZE,starty+7*GRIDSIZE,startx+6*GRIDSIZE,starty+6*GRIDSIZE);
				g.drawLine(startx+6*GRIDSIZE,starty+6*GRIDSIZE,startx+7*GRIDSIZE,starty+7*GRIDSIZE);
				g.drawLine(startx+7*GRIDSIZE,starty+7*GRIDSIZE,endx+2,starty-2*GRIDSIZE);
				g.drawLine(startx+7*GRIDSIZE,starty+9*GRIDSIZE,endx,endy+2*GRIDSIZE);
				g.drawLine(startx,starty+2*GRIDSIZE,startx+5*GRIDSIZE,starty+7*GRIDSIZE);
			}
		}
	/**
	 * vykresluje trajektoriu gul pre Oneskorenie
	 * @param g
	 */		
		private void kresliOneskorenie(Graphics g)
		{ 
			Dimension d = getSize();  //zisti rozmer komponenty kde bude lezat mriezka
			int GRIDSIZE = Math.min(d.height/sizY,d.width/sizX); //urci velkost mriezky a ulozi do GRIDSIZE
		    int startx = (d.width-GRIDSIZE*sizX)/2; //urci posun  x od [0,0] presuvame [0,0]
			int starty = (d.height-GRIDSIZE*sizY)/2; //urci posun y od [0,0] na [startx,starty] 
			int endx = startx+GRIDSIZE*sizX;
			int endy = starty+GRIDSIZE*sizY;
			
			g.setColor(Color.RED);
			{
				g.drawLine(startx,endy-2,endx,starty-2);
			}
			g.setColor(Color.BLUE);
			{
				g.drawLine(startx,endy,startx+6*GRIDSIZE,starty+10*GRIDSIZE);
				g.drawLine(startx+6*GRIDSIZE,starty+10*GRIDSIZE,startx+8*GRIDSIZE,starty+12*GRIDSIZE);
				g.drawLine(startx+8*GRIDSIZE,starty+12*GRIDSIZE,startx+11*GRIDSIZE,starty+9*GRIDSIZE);
				g.drawLine(startx+11*GRIDSIZE,starty+9*GRIDSIZE,startx+9*GRIDSIZE,starty+7*GRIDSIZE);
				g.drawLine(startx+9*GRIDSIZE,starty+7*GRIDSIZE,endx,starty);
			}
		}
	/**
	 * vykresluje trajektoriu gul pre Posun A
	 * @param g
	 */	
		private void kresliPosunO2(Graphics g)
		{ 
			Dimension d = getSize();  //zisti rozmer komponenty kde bude lezat mriezka
			int GRIDSIZE = Math.min(d.height/sizY,d.width/sizX); //urci velkost mriezky a ulozi do GRIDSIZE
		    int startx = (d.width-GRIDSIZE*sizX)/2; //urci posun  x od [0,0] presuvame [0,0]
			int starty = (d.height-GRIDSIZE*sizY)/2; //urci posun y od [0,0] na [startx,starty] 
			int endx = startx+GRIDSIZE*sizX;
			int endy = starty+GRIDSIZE*sizY;
			
			g.setColor(Color.BLUE);
			{
				g.drawLine(startx+6*GRIDSIZE,starty+8*GRIDSIZE,startx+8*GRIDSIZE,starty+6*GRIDSIZE);
				g.drawLine(startx+8*GRIDSIZE,starty+6*GRIDSIZE,endx,endy-2*GRIDSIZE);
				g.drawLine(startx,starty+2*GRIDSIZE,startx+6*GRIDSIZE,starty+8*GRIDSIZE);
			}
			g.setColor(Color.RED);
			{
				g.drawLine(startx,starty+2*GRIDSIZE+2,startx+14*GRIDSIZE,endy+2);
			}
		}
/**
 * vykresluje trajektoriu gul pre Posun B
 * @param g
 */		
		private void kresliPosunO3(Graphics g)
		{ 
			Dimension d = getSize();  //zisti rozmer komponenty kde bude lezat mriezka
			int GRIDSIZE = Math.min(d.height/sizY,d.width/sizX); //urci velkost mriezky a ulozi do GRIDSIZE
		    int startx = (d.width-GRIDSIZE*sizX)/2; //urci posun  x od [0,0] presuvame [0,0]
			int starty = (d.height-GRIDSIZE*sizY)/2; //urci posun y od [0,0] na [startx,starty] 
			int endx = startx+GRIDSIZE*sizX;
			int endy = starty+GRIDSIZE*sizY;
			
			g.setColor(Color.BLUE);
			{
				g.drawLine(startx,starty+2*GRIDSIZE,startx+8*GRIDSIZE,starty+10*GRIDSIZE);
				g.drawLine(startx+8*GRIDSIZE,starty+10*GRIDSIZE,startx+12*GRIDSIZE,starty+6*GRIDSIZE);
				g.drawLine(startx+12*GRIDSIZE,starty+6*GRIDSIZE,endx,endy-6*GRIDSIZE);
				
			}
			g.setColor(Color.RED);
			{
				g.drawLine(startx,starty+2*GRIDSIZE+2,startx+14*GRIDSIZE,endy+2);
			}
		}
		
	
//prekrytie kresliacich metod
	/**
	 * implementacia (prekrytie) metody
	 * Metoda realizuje update
	 */
	public void update(Graphics g)
	{
		paint(g);
	}
	/**
	 * implementacia (prekrytie) metody
	 * Metoda realizuje vlastne vykreslovanie, a kreslenie trejektorii gul pre prislusne demo
	 */	
	public void paint(Graphics g) 
	{ 
		Dimension d = getSize();
		// cistime obrazovku
		g.clearRect (0,0,d.width,d.height);
		//vlastne kreslenie
		kresli(g);
		if(demo==6)	
			kresliIgate(g);
		if(demo==7)
			kresliSgate(g);
		if(demo==8)
			kresliNetrivialne(g);
		if(demo==9)
			kresliOneskorenie(g);
		if(demo==4)	
			kresliPosunO2(g);
		if(demo==5)	
			kresliPosunO3(g);
	}
}